var XHR = XMLHttpRequest.prototype;
var open = XHR.open;
XHR.open = function (method, url) {
    this.url = url;
    this.origin = location.href.toUpperCase();
    return open.apply(this, arguments);
}

var setRequestHeader = XHR.setRequestHeader;
var headers = {};
XHR.setRequestHeader = function (key, value) {
    headers[key] = value;
    return setRequestHeader.apply(this, arguments);
}

var send = XHR.send;
XHR.send = function (body) {
    this.addEventListener('load', function () {
        window.postMessage(JSON.parse(JSON.stringify({ body: body, origin: this.origin, headers: headers, response: this.response, status: this.status, url: this.url })), '*')
    });

    return send.apply(this, arguments);
}